"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var tmpl = _ref.template;


  var handled = tmpl("{\n if (typeof(window.makitoo) !== \"undefined\") window.makitoo.report(\"handled\", BUILD, PROBE, E);\nCATCH\n}\n");

  var unhandled = tmpl("{\n  try {\n      BODY\n  } catch(ex) {\n if (typeof(window.makitoo) !== \"undefined\")\n       window.makitoo.handleException(\"unhandled\", BUILD, PROBE, ex);\n  }\n}");

  var callback = tmpl("{\nif (typeof(window.makitoo) !== \"undefined\") {\n  PROBES\n}\nBODY\n}");

  var callback_param = tmpl("if (E instanceof Error) window.makitoo.report(\"callback\", BUILD, PROBE, E);");

  var buildid = Date.now();
  var getBuildId = function getBuildId(opts) {
    if (typeof opts !== "undefined" && opts.test) return 1;
    return buildid;
  };
  var probeid = 1;
  var generateProbe = function generateProbe(opts) {
    if (typeof opts !== "undefined" && opts.test) return 1;
    return probeid++;
  };

  return {
    visitor: {
      CatchClause: function CatchClause(path, state) {
        if (state.opts && state.opts.handled) {
          if (!path.node._generated) path.node.body = handled({
            BUILD: t.numericLiteral(getBuildId(state.opts)),
            PROBE: t.numericLiteral(generateProbe(state.opts)),
            E: path.node.param,
            CATCH: path.node.body.body });
        }
      },
      Function: function Function(path, state) {
        // Add error callback for parameters
        if (state.opts && state.opts.callback) {
          var params_tmpl = [];
          for (var i in path.node.params) {
            var param = path.node.params[i];
            params_tmpl.push(callback_param({
              BUILD: t.numericLiteral(getBuildId(state.opts)),
              PROBE: t.numericLiteral(generateProbe(state.opts)),
              E: param
            }));
          }

          path.node.body = callback({
            PROBES: params_tmpl,
            BODY: path.node.body.body
          });
        }

        // Generate a try/catch
        if (state.opts && state.opts.hotcatch) {
          path.node.body = unhandled({
            BUILD: t.numericLiteral(getBuildId(state.opts)),
            PROBE: t.numericLiteral(generateProbe(state.opts)),
            BODY: path.node.body.body
          });
          path.node.body.body[0].handler._generated = true;
        }
      }
    }
  };
};

module.exports = exports["default"];